#ifndef TWN_GL_15_RENDERING_H
#define TWN_GL_15_RENDERING_H

/*
 * OpenGL 1.5 and any 2.0+ compatibility version render implementation.
 */

#include "twn_rendering_c.h"
#include "twn_gl_any_rendering_c.h"

#ifdef EMSCRIPTEN
#include <GLES2/gl2.h>
#else
#include <glad/glad.h>
#endif

#include <stb_truetype.h>


void render_circle(const struct circle_primitive *circle);

void render_rectangle(const struct rect_primitive *rectangle);

void use_space_pipeline(void);

void use_2d_pipeline(void);

void use_texture_mode(enum texture_mode mode);

/* uses present in 1.5 buffer mapping feature */
vertex_buffer_builder build_vertex_buffer(vertex_buffer buffer, size_t bytes);

/* collects bytes for sending to the gpu until all is pushed, which is when false is returned */
bool push_to_vertex_buffer_builder(vertex_buffer_builder *builder,
                                   void *bytes,
                                   size_t size);

void finally_render_sprites(struct primitive_2d const primitives[],
                            struct sprite_batch batch,
                            vertex_buffer buffer);

size_t get_sprite_payload_size(struct sprite_batch batch);

bool push_sprite_payload_to_vertex_buffer_builder(struct sprite_batch batch,
                                                  vertex_buffer_builder *builder,
                                                  t_fvec2 v0, t_fvec2 v1, t_fvec2 v2, t_fvec2 v3,
                                                  t_fvec2 uv0, t_fvec2 uv1, t_fvec2 uv2, t_fvec2 uv3,
                                                  t_color color);

void finally_draw_uncolored_space_traingle_batch(struct mesh_batch const *batch,
                                                 t_texture_key texture_key,
                                                 vertex_buffer buffer);

size_t get_text_payload_size(void);

bool push_text_payload_to_vertex_buffer_builder(struct font_data const *font_data,
                                                vertex_buffer_builder *builder,
                                                stbtt_aligned_quad quad);

void finally_draw_text(struct font_data const *font_data,
                       size_t len,
                       t_color color,
                       vertex_buffer buffer);

#endif
